package net.mysoftworks.modulecompiler.model.meta;


import net.mysoftworks.modulecompiler.model.AllowedValue;
import net.mysoftworks.modulecompiler.model.values.RawValue;
import net.mysoftworks.modulecompiler.model.visitor.MetaFieldVisitor;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.PostActivate;
import javax.ejb.PrePassivate;
import javax.persistence.*;
import javax.ws.rs.container.PreMatching;
import java.util.ArrayList;
import java.util.List;

/**
 * MetaGruppo generated by hbm2java
 */
@Entity
@DiscriminatorValue("LIST")
public class MetaListField extends MetaField implements java.io.Serializable {

	public enum LIST_TYPE {
		CHECKBOX,RADIO,SELECT
	}
	private static final long serialVersionUID = 1L;

	@Column(name="SUB_TYPE")
	@Enumerated(EnumType.STRING)
	private LIST_TYPE listType= LIST_TYPE.SELECT;

	public LIST_TYPE getListType() {
		return listType;
	}

	public void setListType(LIST_TYPE listType) {
		this.listType = listType;
	}

	public MetaListField(){super(BUSINESS_FIELD_TYPE.LIST);	}

	@Override
	public Object viewValue(RawValue rawValue) {
		if (rawValue==null) return null;
		for(AllowedValue av: allowedValues) {
			if (av.getCodice().equals(rawValue.getStringValue())) return av.getDescrizione();
		}
		return null;
	}

	public MetaListField(MetaListField source) {
		super(source);
		this.listType = source.listType;
		this.allowedValues = source.allowedValues;
	}
	@OneToMany(cascade = {CascadeType.PERSIST,CascadeType.MERGE,CascadeType.REMOVE},mappedBy = "field",
			/*cascade = {CascadeType.DETACH,CascadeType.PERSIST,CascadeType.REFRESH,CascadeType.REMOVE},*/fetch = FetchType.LAZY)
//	@JoinColumn(name = "ID_FIELD")
	@OrderBy("codice desc")
	private List<AllowedValue> allowedValues = new ArrayList<>();

	public List<AllowedValue> getAllowedValues() {
		return allowedValues;
	}

	public void setAllowedValues(List<AllowedValue> allowedValues) {
		this.allowedValues = allowedValues;
	}

	public void clearAllowedValue() {
		allowedValues.clear();
	}

	public void addValue(AllowedValue av) {
		allowedValues.add(av);
		av.setField(this);
	}


//	@PrePersist
	public void prePersist(){
		if (CollectionUtils.isNotEmpty(allowedValues)) {
			for(AllowedValue av: allowedValues) {
//				av.setId(null);
			}
		}
	}

//	@PreRemove
//	public void preRemove(){
//		System.out.println("\n\n===============preRemove:"+toString());
//	}
//	@PreUpdate
//	public void preUpdate(){
//		System.out.println("\n\n===============preUpdate:"+toString());
//	}
//	@PreDestroy
//	public void preDestroy(){
//		System.out.println("\n\n===============preDestroy:"+toString());
//	}
//	@PrePassivate
//	public void prePassivate(){
//		System.out.println("\n\n===============prePassivate:"+toString());
//	}
//
//	@PostConstruct
//	public void postConstruct(){
//		System.out.println("\n\n===============postConstruct:"+toString());
//	}
//
//	@PostActivate
//	public void postActivate(){
//		System.out.println("\n\n===============postActivate:"+toString());
//	}
//	@PostLoad
//	public void postLoad(){
//		System.out.println("\n\n===============postLoad:"+toString());
//	}
//	@PostPersist
//	public void postPersist(){
//		System.out.println("\n\n===============postPersist:"+toString());
//	}
//	@PostRemove
//	public void postRemove(){
//		System.out.println("\n\n===============postRemove:"+toString());
//	}
//	@PostUpdate
//	public void postUpdate(){
//		System.out.println("\n\n===============postupdate:"+toString());
//	}



	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder("MetaListField{");
		sb.append("listType=").append(listType);
		sb.append("\nav=").append(StringUtils.join(allowedValues));
		sb.append('\n').append(super.toString());
		return sb.toString();
	}

	public void accept(MetaFieldVisitor visitor) {
		visitor.visit(this);
	}
}
